#include <FK/FK.h>
#include "VolumeLineModel.h"

class MyEffectModel : public fk_Model {
public:
	void preShader()
	{
		glBlendFunc(GL_ONE, GL_ONE);
		glDepthMask(GL_FALSE);
		//glDisable(GL_DEPTH_TEST);
	};
	void postShader()
	{
		//glEnable(GL_DEPTH_TEST);
		glDepthMask(GL_TRUE);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	};
};

int main(int argc, char *argv[])
{
	Fl_Window		mainWindow(512, 512, "FK TEST");
	fk_Model		camera, blockModel, lightModel;
	fk_Light		light;
	fk_Block		block(50.0, 70.0, 40.0);
	fk_Scene		scene;
	fk_Window		window(0, 0, 512, 512);

	fk_RectTexture		rect;
	MyEffectModel		effectModel;
	int					step = 0;

	fk_VolumeLineModel	vLine;
	fk_Image			img;


	mainWindow.end();
	fk_InitMaterial();

	// Ɩ̐ݒ
	lightModel.setShape(&light);
	lightModel.setMaterial(White);
	lightModel.glMoveTo(0.0, 0.0, 0.0);
	lightModel.glFocus(-1.0, -1.0, -1.0);

	// ̂̐ݒ
	blockModel.setShape(&block);
	blockModel.setMaterial(Yellow);

	rect.readPNG("Locus.png");
	rect.setTextureMode(FK_TEX_REPLACE);
	rect.setTexRendMode(FK_TEX_REND_SMOOTH);
	rect.setTextureSize(300.0, 300.0);
	effectModel.setShape(&rect);

	// effBXvCXgɓo^
	scene.setBlendStatus(true);
	scene.entryCamera(&camera);
	scene.entryModel(&blockModel);
	scene.entryModel(&lightModel);
	scene.entryModel(&effectModel);

	// EBhEփfBXvCXgo^
	window.setScene(&scene);

	// _̈ʒuƎpݒ
	camera.glMoveTo(0.0, 0.0, 500.0);
	camera.glFocus(0.0, 0.0, 0.0);
	camera.glUpvec(0.0, 1.0, 0.0);

	mainWindow.show();
	window.show();

	vLine.cgInit();
	if(!img.readBMP("1d_cyan.bmp")) fl_alert("readBMP() err!");
	vLine.setImage(&img);
	vLine.pushLine(fk_Vector(-100.0, 0.0, 0.0), fk_Vector(100.0, 0.0, 0.0), 50.0);
	scene.entryModel(&vLine);

	while(true) {

		if(mainWindow.visible() == 0) {
			if(Fl::wait() == 0) {
				break;
			} else {
				continue;
			}
		}

		if(window.drawWindow() == 0) break;
		if(Fl::check() == 0) break;
		if(window.winOpenStatus() == false) continue;

		// ̂ Y Sɉ]
		blockModel.glRotateWithVec(0.0, 0.0, 0.0, fk_Y, FK_PI/100.0);
		vLine.glRotateWithVec(0.0, 0.0, 0.0, fk_Y, FK_PI/100.0);

		if(window.getSpecialKeyStatus(FK_UP, false)) {
			effectModel.glTranslate(0.0, 0.0, -1.0);
		}
		if(window.getSpecialKeyStatus(FK_DOWN, false)) {
			effectModel.glTranslate(0.0, 0.0, 1.0);
		}

		/*
			fk_TexCoord(0.0, 1.0);
			fk_TexCoord(2.0, 0.8);
			fk_TexCoord(2.0, 1.0);
			fk_TexCoord(4.0, 0.8);
			fk_TexCoord(4.0, 1.0);
			fk_TexCoord(6.0, 0.8);
			fk_TexCoord(6.0, 1.0);
			fk_TexCoord(8.0, 0.8);
			fk_TexCoord(8.0, 1.0);
			fk_TexCoord(1.0, 0.8);
		*/
		rect.setTextureCoord((double)(step%5)*0.2, 1.0-(double)(step/5)*0.2,
								(double)((step%5)+1)*0.2, 1.0-(double)((step/5)+1)*0.2);
		step++;
		if(step >= 25) step = 0;

		static unsigned long regTime = window.getNow();
		while(window.getNow() - regTime < 16) Sleep(1);
		regTime = window.getNow();
	}

	return 0;
}
